#pragma once
#include "bj_airplay.h"

class BJAirplayCallbackImp
{
public:

	static int32_t OnStartMirrorPlayer(uint32_t playerId, const char* ip, const char* device_model, const char* device_name);

	/**
	* \brief           Write mirror audio PCM frame to player.
	* \param bitsdep   bitsdep of audio, 16 is default.
	* \param channels  channels of audio, 2 is default.
	* \param sampleRate sampleRate of audio, 44100 is default. .
	* \return          void
	*/
	static void NotifyMirrorAudioCodecInfo(uint32_t playerId, int32_t bitsdep, int32_t channels, int32_t sampleRate);

	/** ֪ͨӦþƵ
	*
	*     ͶУSDKյƵݺн룬øýӿ֪ͨӦòѾPCMƵݡ
	*     @param playerId ŻỰID(IDSDKڲͳһ䣬ȫΨһ)
	*     @param p_src   ָƵݿָ
	*     @param size    Ƶݿĳ
	*     @param ptsValue ƵݶӦʱ
	*     @return Copied size. (unit: byte)
	*     @note   ӦյƵݺн벢ţͬʱҪʱƵͬơ
	*/
	static uint32_t OnMirrorAudioData(uint32_t playerId, const uint8_t *p_src, uint32_t size, int64_t ptsValue);

	/** ֪ͨӦþƵ
	*
	*     ͶУSDKյƵݺøýӿ֪ͨӦòյH264Ƶݡ
	*     @param playerId ŻỰID(IDSDKڲͳһ䣬ȫΨһ)
	*     @param p_src ָƵݿָ
	*     @param size    Ƶݿĳ
	*     @param ptsValue ƵݶӦʱ
	*     @return Copied size. (unit: byte)
	*     @see    NotifyMirrorAudioCodecInfo()  ƵĲϢͨNotifyMirrorAudioCodecInfo֪ͨӦ
	*     @note   ӦյƵݺн벢ţͬʱҪʱƵͬơ
	*/
	static uint32_t OnMirrorVideoData(uint32_t playerId, const uint8_t *p_src, uint32_t size, int64_t ptsValue);

	/** 񲥷ƵתǶ֪ͨ
	*
	*     IPAD/IPHONEն
	*     @param playerIdŻỰID(IDSDKڲͳһ䣬ȫΨһ)
	*     @param angle ƵתǶȣȡֵΧΪ0,90,180,270нǶΪ˳ʱ뷽Ƕȡ
	*     @return    
	*     @note   Ӧյ¼󣬲ҪݸýǶתȷʾƵ
	*/
	static void OnRotateMirrorVideo(uint32_t playerId, int angle);

	/** ֹͣ񲥷
	*
	*     ֹͣ񲥷ŻỰûֹͣͶɾͶлURLŵȳᴥýӿڡ
	*     @param playerIdŻỰID(IDSDKڲͳһ䣬ȫΨһ)
	*     @return    
	*     @note   ӦҪͷŸûỰԴ
	*/
	static void OnStopMirrorPlayer(uint32_t playerId);

	/** ʼƵ
	*
	*     ʼ񲥷ŻỰûͶURLŻص񲥷ŵȳᴥýӿڡ
	*     @param playerId  ŻỰID(IDSDKڲͳһ䣬ȫΨһ)
	*     @param ip 豸IPַ
	*     @param device_model 豸豸ͺţiphone6
	*     @param device_name 豸豸
	*     @return    eg:@retval 0:Ӧò㿪ʼųɹ @retval other:Ӧò㲥ʧܣSDKڲûỰ
	*     @note   ӦҪסplayerIdplayerIdάŻỰؽӿڶֶͨνй
	*/
	static int OnStartAudioPlayer(uint32_t playerId, const char* ip, const char* device_model, const char* device_name);

	/** ֪ͨӦƵ
	*
	*     ƵͶУSDKյƵݺн룬øýӿ֪ͨӦòѾPCMƵݡ
	*     @param playerId ŻỰID(IDSDKڲͳһ䣬ȫΨһ)
	*     @param p_src   ָƵݿָ
	*     @param size    Ƶݿĳ
	*     @param ptsValue ƵݶӦʱ
	*     @return Copied size. (unit: byte)
	*     @note   ӦյƵݺн벢ţͬʱҪʱƵͬơ
	*/
	static uint32_t OnAudioData(uint32_t playerId, const uint8_t *p_src, uint32_t size, int64_t ptsValue);

	static void RefreshCoverArtFromBuffer(uint32_t playerId, const uint8_t *p_src, int size);

	static void SetVolume(uint32_t playerId, int volumePercent);

	/** ֹͣƵ
	*
	*     ֹͣ񲥷ŻỰûֹͣͶɾͶлURLŵȳᴥýӿڡ
	*     @param playerIdŻỰID(IDSDKڲͳһ䣬ȫΨһ)
	*     @return    
	*     @note   ӦҪͷŸûỰԴ
	*/
	static void OnStopAudioPlayer(uint32_t playerId);

	/** ֲ֪ͨʱƵݵĸʽ
	* @param playerIdŻỰID(IDSDKڲͳһ䣬ȫΨһ)
	* @param bitsdep   bitsdep of audio, 16 is default.
	* @param channels  channels of audio, 2 is default.
	* @param sampleRate sampleRate of audio, 44100 is default. .
	* @return          void
	*/
	static void NotifyAudioCodecInfo(uint32_t playerId, int32_t bitsdep, int32_t channels, int32_t sampleRate);

    static void RefreshTrackInfo(uint32_t playerId, const char* album, const char* title, const char* artist);

	/** ʼURLƵŻỰ
	* @param playerIdŻỰID(IDSDKڲͳһ䣬ȫΨһ)
	* @param url	   ҪŵƵURL
	* @return    eg:@retval 0:Ӧò㿪ʼųɹ @retval other:Ӧò㲥ʧܣSDKڲûỰ
	*/
	static int32_t OnStartVideoPlayback(uint32_t playerId, const char *ip, const char *url);

	/** URLƵŻỰ
	* @param playerIdŻỰID(IDSDKڲͳһ䣬ȫΨһ)
	* @return    void
	* @note   ӦӦͷŲԴ
	*/
	static void OnStopVideoPlayback(uint32_t playerId);

	/** URLƵŻỰ
	* @param playerIdŻỰID(IDSDKڲͳһ䣬ȫΨһ)
	* @return    void
	* @note   ӦӦͷŲԴ
	*/
	static void OnPauseVideoPlayback(uint32_t playerId);
	static void OnResumeVideoPlayback(uint32_t playerId);
	static void OnSeekVideoBySec(uint32_t playerId, int64_t position);
	static int32_t OnGetVideoPositionMSec(uint32_t playerId);
	static int32_t OnGetVideoDurationMSec(uint32_t playerId);
    static int32_t OnGetVideoPlayerStatus(uint32_t playerId);


    /**ʼ
	* @param playerIdŻỰID(IDSDKڲͳһ䣬ȫΨһ)
	* @param ip 豸IPַ
	* @return    eg:@retval 0:Ӧò㿪ʼųɹ @retval other:Ӧò㲥ʧܣSDKڲûỰ
	* @note  ios9ǰϵͳ֧
	*/
	static int32_t OnStartPhotoPlayer(uint32_t playerId, const char* ip);

	/**ʼ
	* @param playerIdŻỰID(IDSDKڲͳһ䣬ȫΨһ)
	* @param picData, ָͼƬݵָ
	* @param size, ݵĴС
	* @return void
	* @note ios9ǰϵͳ֧
	*/
	static void OnPlayPhoto(uint32_t playerId, const uint8_t* picData, int size);

	/**
	* @param playerIdŻỰID(IDSDKڲͳһ䣬ȫΨһ)
	* @return void
	* @note ios9ǰϵͳ֧
	*/
	static void OnStopPhotoPlayer(uint32_t playerId);


    static void OnShowPinCode(const char* ip,const char* pincode);

	/**PIN֤ɹ
	* @param ip
	* @return void
	* @note
	*/
	static void OnVerifyPinSuccess(const char* ip);


    static void OnProbePlayerAbility(const char* ip, BJAirPlayAbility* const ability);
};

